#! /usr/local/bin/perl

################################################################################
#
# The modules we require.
#
################################################################################
use Mysql;

if ($ARGV[0] eq "-v") { $DEBUG = 1; }

&main();

sub db_settings
{
################################################################################
#
# Our Database Information
#
################################################################################
$host = "db";
$dbname = "machine";
$user = "janitor";
$pass = "tnidbifb";
}

################################################################################
#
# Connect to the Database
#
################################################################################
sub connectdb
{
   local($dbname) = @_;

   if (!($dbh = Mysql->Connect($host, $dbname, $user, $pass,)))
   {
      die "[connectdb] Database connect failed: $Mysql::db_errstr\n";
   }
}

sub main
{
   &db_settings();
   &connectdb("machine");


sub insert
{
   local($ip,$host) = @_;
   local($qs, $sth);
   
   $qs="INSERT INTO name VALUES ('', '$ip', '$host', '')";
   $sth = $dbh->Query($qs)
      or warn "[insert] Query had some problem: $Mysql::db_errstr\n$qs\n";
   $qs="SELECT id FROM name WHERE name='$host'";
   $sth = $dbh->Query($qs)
      or warn "[insert] Query had some problem: $Mysql::db_errstr\n$qs\n";
   @row=$sth->FetchRow;
   $qs = "INSERT INTO changes VALUES ('$row[0]', 'root', '00000000');
   $sth = $dbh->Query($qs)
      or warn "[insert] Query had some problem: $Mysql::db_errstr\n$qs\n";
   $qs = "INSERT INTO specs VALUES ('$row[0]', '', '', '', '', '');
   $sth = $dbh->Query($qs)
      or warn "[insert] Query had some problem: $Mysql::db_errstr\n$qs\n";
   $qs = "INSERT INTO owner VALUES ('$row[0]', '',  '', '');
   $sth = $dbh->Query($qs)
      or warn "[insert] Query had some problem: $Mysql::db_errstr\n$qs\n";
   return($row[0]);
}

sub add_aliases
{
   local($id) = @_;
   local($qs);

   for ($i=0; $i<=$#aliases; $i++)
   {
      $_ = $aliases[$i];
      last if (/#/);
      $qs="INSERT INTO aliases VALUES ('$id', '$aliases[$i]')";
      $sth = $dbh->Query($qs)
         or warn "[add_aliases] Query had some problem: $Mysql::db_errstr\n$qs\n";
   }
   if (!$#aliases)
   {
      $qs="INSERT INTO aliases VALUES ('$id', '')";
      $sth = $dbh->Query($qs)
         or warn "[add_aliases] Query had some problem: $Mysql::db_errstr\n$qs\n";
   }
}

sub main
{
   &connectdb();
   open (MASTER, "/etc/hosts");
   while (<MASTER>)
   {
      chop;
      next if ((/^#/));
      ($ip, $host, @aliases) = split(/\s+/, $_);
      print "Processing $host with $ip and $#aliases aliases...\n" if($DEBUG);
      $id=&insert($ip, $host);
      print "Got id $id...\n" if($DEBUG);
      &add_aliases($id);
   }
   close(MASTER);
}
